'use strict';

var Queue = function() {
  this.tasks = [];
};

Queue.prototype = {
  isEmpty: function() {
    var tasksLength = this.tasks.length,
        empty = tasksLength === 0;  ///

    return empty;
  },

  push: function(method, cb) {
    var task = {
      method: method,
      cb: cb
    };

    var empty = this.isEmpty();

    this.tasks.push(task);

    if (empty) {
      method(this.cb.bind(this));
    }
  },

  cb: function() {
    var task = this.tasks.shift(),
        cb = task.cb;

    if (cb) {
      cb.apply(null, arguments);
    }

    this.next();
  },

  next: function() {
    var empty = this.isEmpty();

    if (!empty) {
      var task = first(this.tasks),
          method = task.method;

      method(this.cb.bind(this));
    }
  }
}

function first(array) { return array[0]; }

module.exports = Queue;
